-- Cooldown Module

function SN:StartCastDelay(args)
	SN:CreateBar(args[1], args[2], args[3], args[4], args[5], args[6])
end

function SN:CoolDowns()
	
	local f = SN.F
	local m = SN.Media
	--Make the frames db local
	local v = SN.db.profile.Frames

	f.cooldowns = SN:MakeFrame("CDGroup", "cooldowns", "SN:arg4", 24)
	f.cooldowns:SetScript("OnEvent", function(self, event, unit, ...)
		SN:UpdateCooldown(self, event, unit, ...)
	end)

	--Register our events for the frame
	f.cooldowns:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function SN:UpdateCooldown(self, event, unit, ...)

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then

		local type, _, sourceGUID, sourceName, _, _, destGUID, destName =  ...
		local spellId, spellName, spellSchool = select(11, ...)

		--Cycle through our cooldown list
		for i, cooldown in pairs(SN.db.profile.cooldowns) do
			if type == "SPELL_CAST_SUCCESS" then
				if spellId == cooldown.id then
					--Check to see if the cd is a personal only and also if it is enable
					if (not SN.db.profile.CD.raid) and cooldown.type == "personal" and cooldown.enable then
						if sourceGUID == UnitGUID("player") then
							--Check to make up for a cd that requires a cast before it goes on CD.
							local cast = select(7, GetSpellInfo(spellId))
							cast = cast * 0.001
							if cast > 0 then
								args = { self, cooldown, cooldown.CD, sourceName, sourceGUID, spellName }
								SN:ScheduleTimer("StartCastDelay", cast, args)
							else
								SN:CreateBar(self, cooldown, cooldown.CD, sourceName, sourceGUID, spellName)
							end
						end
					--Check to see if it's a raid CD and is it enabled.
					elseif (SN.db.profile.CD.raid) and cooldown.type == "raid" and cooldown.enable then
						if UnitInParty(sourceName) or UnitInRaid(sourceName) or (sourceGUID == UnitGUID("player")) then
							--Check to make up for a cd that requires a cast before it goes on CD.
							local cast = select(7, GetSpellInfo(spellId))
							cast = cast * 0.001
							if cast > 0 then
								args = { self, cooldown, cooldown.CD, sourceName, sourceGUID, spellName }
								SN:ScheduleTimer("StartCastDelay", cast, args)
							else
								SN:CreateBar(self, cooldown, cooldown.CD, sourceName, sourceGUID, spellName)
							end
						--Send the raid CD to see if it's supposed to be announced.
						SN:AnnounceCD(cooldown, sourceName)
						end
					end
				end
			end
		end
	end
end